package models;

import javax.jdo.annotations.Index;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToOne;

import eye.util.StringUtil;

@Entity
public class Note extends EyeModel {
	@Index
	@Column(columnDefinition = "VARCHAR(40)")
	public String name;

	// Denormalized for ease of use.
	@ManyToOne

	@Index
	public Account account;

	@Override
	public String getName() {
		return name;
	}

	@Override
	public EyeModel getOwner() {
		return account;
	}

	@Override
	public String toString() {
		return account + "'s notes on " + name + ":" + StringUtil.cutOff(description, 10);
	}
}
