package models;

import eye.transfer.EyeRecord;
import eye.transfer.EyeType;
import eye.util.ExceptionUtil;
import eye.util.StringUtil;
import eye.util.logging.Log;
import eye.util.logging.Log.Cat;

public class Notes extends AccountMembers<Note> {

	@Override
	public Note ensure(EyeRecord r) {
		String name = r.getName();
		assert StringUtil.hasContent(name);
		Note note = get(name);
		if (note == null) {
			note = create();
			note.name = name;
			note.save();
		}
		return note;

	}

	@Override
	public EyeType getEyeType() {
		return EyeType.note;
	}

	@Override
	public EyeRecord getModels() {
		throw ExceptionUtil.throwUnsupported();
	}

	public EyeRecord load(String name) {
		Note n = get(name);
		Log.config(() -> {
			String message = " load: " + (n == null ? "no note for " + name : n.toString());
			return message;
		}, Cat.NOTE);
		if (n == null) {
			return new EyeRecord();
		} else {
			return load(n);
		}
	}

	@Override
	public Note save(EyeRecord r) {
		Note n = super.save(r);
		Log.config(() -> {
			return " saved: " + n.toString();
		}, Cat.NOTE);
		return n;

	}

	@Override
	protected void setAccount(Note child, Account account) {
		child.account = account;

	}

	@Override
	protected void setName(Note child, String name) {
		child.name = name;
	}

}
