package models;

import static eye.EyeConstants.*;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.ManyToMany;

import eye.play.control.PlayControl;
import eye.transfer.EyeData;

@Entity
/** A really bad score, used to help render correctly */
public class PickFilter extends Strategy {
	public double badScore = -10;
	/** A great score, used to help render correctly */
	public double greatScore = 10;
	public int maxHoldings;
	public String customGroup;
	public String customSize;
	public Integer customGroupMax;
	public String customGroupList;
	public String backtestData;

	@ManyToMany
	public Strategy stopLoss;

	@ManyToMany
	public Strategy stopGain;

	@ManyToMany
	public Strategy rebalance;

	@ManyToMany
	public Strack tradingModel;

	@ManyToMany
	public List<PickFilter> fakeTickers = new ArrayList();
	public double tradingCost;

	public final void addTradingRules(EyeData data) {
		data.setIfNull(REF_GAIN, stopGain);
		data.setIfNull(REF_STOP, stopLoss);
		data.setIfNull(TRADING_COST, tradingCost);
		data.setIfNull(TRADING_MODEL, tradingModel);
		data.setIfNull(MAX_HOLDINGS, maxHoldings);

	}

	@Override
	public void delete(boolean ignoreReferences) {
		if (ignoreReferences == false) {

			for (Watchlist list : PlayControl.watchlists.findAll()) {
				if (list.inFilters.contains(this) || list.outFilters.contains(this)) {
					list.inFilters.remove(this);
					list.outFilters.remove(this);
				}
			}

		}

		createQuery().delete(this);
	}

	public EyeData getStrategy() {
		EyeData data = PlayControl.getEnv().yaml.loadData(content);
		return data;

	}

}