package models;

import java.util.Date;
import java.util.List;

import javax.persistence.Entity;

import eye.play.control.PlayControl;
import eye.ss.database.Query;
import eye.transfer.EyeRecord;
import eye.util.UserException;

@Entity
public class Strack extends Strategy {
	public Date viewBegin;
	public Date viewEnd;
	public String security;
	public String benchmark;

	public Strack() {
		// Should be used for getting values from real system.
	}

	public Strack(Account account) {
		this(account, "GE", account.benchmark);
	}

	public Strack(Account owner, String security) {
		this(owner, security, "SPY");
	}

	public Strack(Account owner, String security, String benchmark) {
		account = owner;
		this.security = security;
		this.benchmark = benchmark;
		validate();
	}

	public static Strack ensureStrack(Account owner, String name) {
		Strack pick = findByName(owner, name);
		if (pick == null) {
			return new Strack(owner, name);
		} else {
			return pick;
		}
	}

	public static Strack findByName(Account owner, String security) {
		return query().findByName(owner.name + "_" + security);
	}

	public static List<Strack> findStracks(Account port) {
		return null;
	}

	public static Query<Strack> query() {
		return Query.create(Strack.class, DB.getEm());
	}

	public void copyTo(EyeRecord next) {
		next.setModel(this);
		next.set("recordAccount", account.name);
	}

	@Override
	public void delete(boolean isAccountDeleting) {
		if (getClass().equals(Strack.class)) {
			if (isAccountDeleting == false) {
				for (Watchlist list : PlayControl.watchlists.findAll()) {
					if (equals(list.tradingModel)) {
						throw new UserException(
								"Cannot delete " + label + " because watchlist " + list.label + " is still using it.",
								true);
					}
				}
			}
		}
		createQuery().delete(this);
	}

	public String toPrettyString() {
		return security;
	}

}
